#!/usr/bin/perl

# Save and then redirect STDERR so that output to STDERR by gnuplot 
# is discarded.

open(SAVEERR, ">&STDERR");

open(STDERR, ">/dev/null");

# Open the pipe to gnuplot.  On Win32, we use a proxy called mxgnuplt.

	open(GNUPLOT, "| mxplot.tcl") || die "Cannot open pipe to mxplot";

# Restore STDERR.

open(STDERR, ">&SAVEERR");

# Do not buffer the gnuplot pipe.

$old_select = select(GNUPLOT);
$| = 1;    
select($old_select);

# Handle commands from the parent program.

while ($input_line = <STDIN>) {

	chop $input_line;  # Get rid of the newline at the end of the string.

	# Handle special commands first.

	if ( $input_line eq "exit" ) {
		print GNUPLOT "exit\n";
		close(GNUPLOT);
		exit;
	}
        print GNUPLOT "$input_line\n";
        next;	# Skip the rest of the block and go back to while(1).

}

# If we get here, our parent process has gone away unexpectedly, so we must
# shut down gnuplot before exiting.

print GNUPLOT "exit\n";

